import * as plugins from '../plugins.js';

export interface IRequest_SendLetter extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IRequest_SendLetter
> {
  method: 'sendLetter';
  request: {
    /**
     * will be used in logs
     */
    description: string;
    /**
     * if you send any PDF / invoice that you have not made sure to be letterxpress compliant
     * we strongly recommend using a cover page
     */
    needsCover: boolean;
    title?: string;
    from?: plugins.tsclass.business.IAddress;
    to?: plugins.tsclass.business.IAddress;
    coverBody?: string;
    service: ('Einschreiben')[];
    pdfAttachments?: Array<{
      name: string;
      binaryAttachmentString: string;
    }>
  };
  response: {
    /**
     * this process id allows status retrieval of the letter
     */
    processId: string;
  };
}